﻿'All program codes are developed in the Biosimulation laboratory, Faculty of Life Sciences, Ritsumeikan University
'Reference; Publications
'A human ventricular myocyte model with refined representation of excitation-contraction coupling 
'Running title;                        'CICR in human ventricular cell model
'Authors;    'Y. Himeno†, K. Asakura†‡, C.Y. Cha†1, H. Memida†, T. Powell2, A. Amano†, and A. Noma†. 
'†Biosimulation Project, College of Life Sciences, Ritsumeikan University,
'Noji Higashi 1-1-1 Kusatsu-City, Shiga-prefecture, Japan
'‡Nippon Shinyaku, Co., Ltd., 14, Nishinosho-Monguchi-cho, Kisshoin, Minami-ku, Kyoto, Japan
'1Oxford Centre for Diabetes Endocrinology and Metabolism,
'University of Oxford, Churchill Hospital, Oxford, OX37 LJ, UK.
'2Department of Pharmacology, University of Oxford, Oxford OX1 3QT, UK

'Solution explorer lists all subclasses.
'Calculate.vb provides tools for Disk Write and Read
'Form.APClamp.vb ;   protocol of the Action potetial clamp experiment
'Form.General.vb;       protocol of the current clamp experiments
'Form.ICaLkinetics.vb ;   protocol to draw kinetics of LCC
'Form.RyRtransient.vb;  protocol of the state transition of the couplon model at the onset of action potential
'Form.scaleI1I2;  protocol for simulation of EAD  by varying the inactivation rate of INaL by using the scaling factor for kI1I2, and DAD by injecting 1~1.5 mM Ca into SRup compartment
'Form.VmClampIV.vb;  protocol of Vm clamp experiment
'Graph.vb; home-made tools for Graphics
'Graph2014.vb  home-made tools for Graphics in 2014
'Model.vb;    All equations of HuVEC model are described in this module class
'
'To select a 'Form' to run the protocol of interest, use 'My Project'  and select a Start up form (O) from the pull-down list in the solution explorer.


Imports System.IO
Public Class Form_VmClampIV
    '********** prepared pens **********
    Public BlackPen As Pen = New Pen(Color.Black, 1)
    Public BlackPen3 As Pen = New Pen(Color.Black, 3)
    Public BluePen As Pen = New Pen(Color.Blue, 1)
    Public BluePen3 As Pen = New Pen(Color.Blue, 3)
    Public RedPen As Pen = New Pen(Color.Red, 1)
    Public RedPen3 As Pen = New Pen(Color.Red, 3)
    Public ChocolatePen As Pen = New Pen(Color.Chocolate, 1)
    Public ChocolatePen3 As Pen = New Pen(Color.Chocolate, 3)
    Public GreenPen As Pen = New Pen(Color.Green, 1)
    Public GreenPen3 As Pen = New Pen(Color.Green, 3)
    Public OlivePen As Pen = New Pen(Color.Olive, 1)
    Public LimePen As Pen = New Pen(Color.Lime, 1)
    Public LimePen3 As Pen = New Pen(Color.Lime, 3)
    Public GreenYellowPen As Pen = New Pen(Color.GreenYellow, 1)
    Public LightCoralPen As Pen = New Pen(Color.LightCoral, 1)
    Public MagentaPen As Pen = New Pen(Color.Magenta, 1)
    Public VioletPen As Pen = New Pen(Color.Violet, 1)
    Public GrayPen As Pen = New Pen(Color.Gray, 1)
    Public GrayPen3 As Pen = New Pen(Color.Gray, 3)
    Public DarkCyanPen As Pen = New Pen(Color.DarkCyan, 1)
    Public DarkMagentaPen As Pen = New Pen(Color.DarkMagenta, 1)
    Public OrangePen As Pen = New Pen(Color.Orange, 1)
    Public cyanPen As Pen = New Pen(Color.Cyan, 1)
    Public yellowPen As Pen = New Pen(Color.Yellow, 1)

    'Dim gradient As New Graph2014.GradientPen
    Public gradient As New Graph2014.GradientPen(1)         '(pen width)

    '********** Graph option **********
    Dim graphVm1 As Graph2014
    Dim graphIm2 As Graph2014
    Dim graphConc3 As Graph2014
    Dim graphGate4 As Graph2014
    'Dim graphBuffer5 As Graph2014
    Dim graphTimeChange6 As Graph2014
    Dim graphGate7 As Graph2014
    Dim graphGate8 As Graph2014
    Dim graphGate9 As Graph2014
 
    Dim graphCa0013 As Graph2014
    ''******************************   Graph parameters **********************************
    Dim MinX1 As Double = 0                               'msec, Abscissa of the graph
    Dim MaxX1 As Double = 100
    Dim IntervalX1 As Double = 10

    Dim MinY1 As Double = -60                          'mV, ordinate, graph of membrane potential
    Dim MaxY1 As Double = 30
    Dim IntervalY1 As Double = 10

    Dim MinY2 As Double = -14                                   'pA/pF, or uM, ordinate , graph of Current
    Dim MaxY2 As Double = 1
    Dim IntervalY2 As Double = 1

    Dim MinY3 As Double = 0                                  'mM, or uM, ordinate , graph of Ca Concentrations                                '
    Dim MaxY3 As Double = 0.6
    Dim IntervalY3 As Double = 0.2

    Dim MinX4 As Double = 10                                 'ms
    Dim MaxX4 As Double = 40
    Dim IntervalX4 As Double = 10

    Dim MinY4 As Double = 0                                  'unitless, Gating variable
    Dim MaxY4 As Double = 0.25
    Dim IntervalY4 As Double = 0.05

    Dim MinX5 As Double = 0
    Dim MaxX5 As Double = 800
    Dim IntervalX5 As Double = 100

    Dim MinY5 As Double = 0                                   'mN/cm2
    Dim MaxY5 As Double = 50
    Dim IntervalY5 As Double = 5

    Dim MinX6 As Double = -50                          'mV,  Vtest
    Dim MaxX6 As Double = 30                           ' mV, Vtest
    Dim IntervalX6 As Double = 10                     'mV

    Dim MinY6 As Double = -1
    Dim MaxY6 As Double = 0.1
    Dim IntervalY6 As Double = 0.1

    Dim MinY8 As Double = 0
    Dim MaxY8 As Double = 0.05
    Dim IntervalY8 As Double = 0.05

    Dim MinY9 As Double = 0
    Dim MaxY9 As Double = 0.1
    Dim IntervalY9 As Double = 0.05

    Dim MinY10 As Double = 0                                   'probability
    Dim MaxY10 As Double = 1
    Dim IntervalY10 As Double = 0.2

    Dim MinY11 As Double = 0                                   '[Ca]SR
    Dim MaxY11 As Double = 0.4
    Dim IntervalY11 As Double = 0.1

    Dim MinY12 As Double = -0.5                                   'ms-1, kYxxxYzzz
    Dim MaxY12 As Double = 0.5
    Dim IntervalY12 As Double = 0.1

    Dim MinY13 As Double = 0                                  'uM  Ca00
    Dim MaxY13 As Double = 40
    Dim IntervalY13 As Double = 10

    '********** File to hold time variables **********
    Dim HV As New HuVECIII
    Dim CsvFileNameVC As String = "CsvHuVECVC.csv"         'store initial values obtained at Vhold
    Dim CsvFileName As String = "CsvHuVEC.csv"
    Dim names1() As String = New String() {"Vm", "TnChCa", "CaMCa", "bufferSRCa", "Lb_jnc", "Lb_iz", "Hb_jnc", "Hb_iz", "Nai", "Ki", _
    "Catot_jnc", "Catot_iz", "Catot_blk", "Ca_SRup", "Catot_SRrl", "O_TM", "I2_TM", "Is_TM", "O_LSM", _
    "I1_LSM", "I2_LSM", "Is_LSM", "Yco_iz", "Yoc_iz", "Yoo_iz", "Yco_blk", "Yoc_blk", "Yoo_blk", "Yooo", _
    "Yooc", "Ycoo", "Ycoc", "Ycco", "Yoco", "Yocc", "paraxrF", "paraxrS", "paraxs1_iz", "paraxs2_iz", "paraxs1_blk", _
    "paraxs2_blk", "a_IKto", "y1_IKto", "y2_IKto", "Pbspm", "E1NCX_iz", "I1NCX_iz", "I2NCX_iz", "E1NCX_blk", _
    "I1NCX_blk", "I2NCX_blk", "P1_6_NaK", "P7_NaK", "P8_13_NaK", "halfSL", "Fb", "Fp", "TSCa3", "TSCa3W", _
    "TSCa3S", "TSS", "TSW", "hw", "hp", "ATPt_cyt", "ADPt_cyt", "Pi_cyt", "PCr_cyt"}

    '********** Membrane current component **********
    Public onset As Double = 50     'start time of external stimulation
    Public offset As Double = 53    'end time of external stimulation

    '********** Time step **********
    Public sweepTime As Double                 'msec   time for each sweep
    Public dt As Double = 0.02                                'ms,  time step for integration
    Public RepeatN As Double                       'Number of repeat the sweeps
    Public elapsedTime As Double               'msec, experimental time

    Dim TtoPlot As Double                            'msec timing for plot the point
    Dim maxTtoPlot As Double = 0.001           '
    '**********     counter     *****************************************
    Public numSweep As Double                 'counter of sweeps

    Dim fileNo As Integer                              'File handler
    Dim strData As String
    Dim valueArray() As String
    '***************************************** save data during simulation *******************************************************
    Dim IsRecord As Boolean
    Dim FileName1 As String
    Dim sw1 As StreamWriter
    Dim RecordTimeStart As Double
    Dim RecordDuration As Double
    Dim RecordInterval As Double
    Dim TtoRecord As Double

    Public Tfreeze As Double = 0
    Dim IsFreezeSlowV As Boolean = False
    Dim IsAddCaNa As Boolean = False
    Dim IsFreezeSR As Boolean = False

    Dim maxICaL As Double
    Dim finalICaL As Double
    Dim maxFb As Double
    Dim maxCablk As Double
    Dim maxRyR As Double       'maximum (yooo + ycoo + ycco + yoco)
    Dim maxdCablkdt As Double
    Dim peakRyR As Double       ' (yooo + ycoo + ycco + yoco) at the time point of maxICaL
    Dim previousYcoo As Double = 0      'start with 0
    Dim noplot As Boolean

    Dim preV As Double = 0
    Dim slopeVmax As Double = 0
    Dim Results(100, 10) As Double

    Dim ICaLzero As Double
    Dim Cablkzero As Double
    Dim Fbzero As Double
    Dim dCablkdtzero As Double
    Dim Jrelzero As Double

    Dim FluxL As Double
    Dim fluxR As Double
    Dim Fluxooc As Double         'flux through yooc
    Dim Fluxcoc As Double         'flux through other 3 conformations
    Dim Fluxccc As Double         'flux through other 3 conformations
    Dim Fluxocc As Double         'flux through other 3 conformations
    Dim Chold As Double         'steady-state C state at the holding potential

    Dim firstDraw As Boolean = True

    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click
        ButtonStart.Visible = False

        If firstDraw Then
            DefineGraph()                              'define graphs
            ClearGraph()
            firstDraw = False
        End If

        ReadForm()                                      'Stimulus strength & Sweeptime max

        DrawAxes()                                        'prepare the graph grids

        HV.DefaultValues()
        'CSVReadAndWrite.ReadCSV(CsvFileName, HV, names1)      'start from the last set of variables

        '*****************conditioning clamp at the holding potential (-50 mV) for 10 sec ****************
        HV.Vtest = HV.Vhold                                      'conditioning at the holding potential Vhold
        dt = 0.02
        sweepTime = 0                                                             'reset sweepTime = 0
        Do                                                             'Calculate for 1 sec at the holding potential of -50 mV
            HV.ModelCell(sweepTime, dt)                'determination of dydt(N) by calculating the model using the variable name
            HV.EulerIntegration(dt)                             'integrate ODE using Euler Method,  renew the value in y(x)
            sweepTime = sweepTime + dt                                  'msec, proceed with the experimental time within one sweep
        Loop While sweepTime < 10000

        CSVReadAndWrite.CreateNewCSV(CsvFileNameVC, HV, names1)   'Replace the old CSV file 
        CSVReadAndWrite.WriteCSV(CsvFileNameVC, sweepTime, HV, 1, names1)      'store variables at the end of the holding potential

        '********************** End of the conditioning pulse at Vhold **************************************************************
        DrawAxes()
        dt = 0.02
        HV.testV = HV.Vhold + HV.VtestInterval         'initial value of testV
        numSweep = 0                                   'reset the counter of sweep
        Do
            My.Application.DoEvents()          'check events

            'HV.DefaultValues()
            CSVReadAndWrite.ReadCSV(CsvFileNameVC, HV, names1)      ' the last set of variables obtained during the holding potential

            '***************** test pulse ****************
            maxRyR = 0
            maxICaL = 0                                                                   'to measure the maximum value of Fb 
            maxCablk = 0
            maxdCablkdt = 0
            maxFb = 0
            finalICaL = 0

            Fluxooc = 0
            Fluxcoc = 0
            Fluxccc = 0
            Fluxocc = 0
            TtoPlot = 0                                                                    'reset counter to plotting interval

            dt = 0.002
            HV.Vtest = HV.testV
            previousYcoo = 0
            noplot = False

            'DrawAxes()

            sweepTime = 0                                                            'reset sweepTime = 0
            Do                           'Calculate individual sweep of the simulation

                HV.ModelCell(sweepTime, dt)                'determination of dydt(N) by calculating the model using the variable name

                If sweepTime > HV.VtestOn And sweepTime < HV.VtestOn + 50 Then
                    Fluxooc = Fluxooc + (HV.kYoocYooo * HV.Yooc - HV.kYoooYooc * HV.Yooo) * dt
                    Fluxcoc = Fluxcoc + (HV.kYcocYcoo * HV.Ycoc - (HV.kYcooYcoc * HV.Ycoo)) * dt
                    Fluxccc = Fluxccc + (HV.kYcccYcco * HV.Yccc - (HV.kYccoYccc * HV.Ycco)) * dt
                    Fluxocc = Fluxocc + (HV.kYoccYoco * HV.Yocc - (HV.kYocoYocc * HV.Yoco)) * dt
                End If
                FluxL = Fluxooc
                FluxR = Fluxcoc + Fluxccc + Fluxocc

                ''''''''''''''''''''''''''''''''''''''''plot or save results''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                'If chkPlot.Checked = True Then
                PlotResults()
                'End If
                ''''''''''''''''''''''''''''''''''''  measure max of Fb, Ca_blk, APD during the testPulse   ''''''''''''''''''''''''''
                If sweepTime < HV.VtestOn - 1 Then        'take the reference level to measure the ICaL amplitude 
                    ICaLzero = HV.ICaL
                    Cablkzero = HV.Cafree_blk
                    dCablkdtzero = HV.dCatot_blkdt
                End If
                PeakSearch()

                If noplot = False And sweepTime > HV.VtestOn + 2 Then
                    If HV.Ycoo < previousYcoo * 0.9999 Then

                        noplot = True
                        previousYcoo = HV.Ycoo
                    Else
                        previousYcoo = HV.Ycoo
                    End If
                Else
                    previousYcoo = HV.Ycoo
                End If

                sweepTime = sweepTime + dt                                  'msec, proceed with the experimental time within one sweep
            Loop While sweepTime < MaxX1

            finalICaL = maxICaL
            WritetxtBox()                                                             'write final values of  variables on memory array
            Results(numSweep, 0) = HV.testV                                  'write final values of  variables
            Results(numSweep, 1) = finalICaL
            Results(numSweep, 2) = maxCablk
            Results(numSweep, 3) = maxFb
            'Results(numSweep, 4) = maxRyR                              'maximum value of pO_RyR
            Results(numSweep, 4) = maxdCablkdt

            HV.testV = HV.testV + HV.VtestInterval
            numSweep = numSweep + 1                                                             'count number of sweeps calculated
        Loop While HV.testV < 32      '32

        maxICaL = 0                                                                      'to measure the maximum value of Fb 
        maxCablk = 0
        maxFb = 0
        maxRyR = 0
        'peakRyR = 0
        Dim N As Double
        For N = 0 To numSweep - 1                   'serach for the maximum value
            If Results(N, 1) > maxICaL Then maxICaL = Results(N, 1)
            If Results(N, 2) > maxCablk Then maxCablk = Results(N, 2)
            If Results(N, 3) > maxFb Then maxFb = Results(N, 3)
            If Results(N, 4) > maxdCablkdt Then maxdCablkdt = Results(N, 4)
        Next

        For N = 0 To numSweep - 1                    'normalize by each maximum value
            Results(N, 5) = Results(N, 1) / maxICaL
            Results(N, 6) = Results(N, 2) / maxCablk
            Results(N, 7) = Results(N, 3) / maxFb
            Results(N, 8) = Results(N, 4) / maxdCablkdt
        Next

        For N = 0 To numSweep - 1                               'plot results
            If Results(N, 0) < 51 Then                             '
                graphTimeChange6.PlotPoint(Results(N, 0), -Results(N, 5), RedPen3)
            Else
                graphTimeChange6.PlotPoint(Results(N, 0), Results(N, 5), RedPen3)           'ICaL peak
            End If
            graphTimeChange6.PlotPoint(Results(N, 0), -Results(N, 8), BluePen3)    'max dCatot_blkdt
        Next

        ButtonStart.Visible = True

    End Sub

    Private Sub PeakSearch()
        If sweepTime > HV.VtestOn + 0.2 And sweepTime < HV.VtestOff - 5 Then
            If Math.Abs(HV.ICaL - ICaLzero) > maxICaL Then maxICaL = Math.Abs(HV.ICaL - ICaLzero) 'peak ICaL
            If (HV.Cafree_blk - Cablkzero) > maxCablk Then maxCablk = HV.Cafree_blk - Cablkzero
            If (HV.Fb - Fbzero) > maxFb Then maxFb = HV.Fb - Fbzero 'maximum Fb
            If (HV.dCatot_blkdt - dCablkdtzero) > maxdCablkdt Then maxdCablkdt = HV.dCatot_blkdt - dCablkdtzero 'maximum Jrel
        End If

    End Sub

    'Private Sub fixSlowVariables()

    '    If IsFreezeSlowV Then
    '        HV.fixzero_slowVariable = 0                                        'fix  [Na]i, [K]i, inactivated state of NCX,  crossbridge  hw & hp, [ATP] and related substrates 
    '        If sweepTime > Tfreeze Then         'fix the slow inactivation of INa
    '            HV.fixzero_INaLslowgate = 0
    '        Else
    '            HV.fixzero_INaLslowgate = 1
    '        End If
    '    Else
    '        HV.fixzero_slowVariable = 1
    '        HV.fixzero_INaLslowgate = 1
    '    End If

    'End Sub

    Public Sub ReadForm()
        If rbBlinkS.Checked Then
            HV.BlinkS = True                   'The model include the blink space
            HV.ratioBS = CDbl(txtRatioBS.Text)               'ratio of gD_bs / gD_nd
        Else
            HV.BlinkS = False                   'No blink space is included in the model
        End If

        HV.clampMode = "Vclamp"         'always Current Clamp Mode

        HV.Vhold = CDbl(txtVhold.Text)
        HV.VtestInterval = CDbl(txtVstep.text)      'mV, interval between two successive test pulse
        HV.VtestOn = CDbl(txtPonset.Text)
        HV.VtestOff = CDbl(txtPoffset.Text)

        If chkIsometric.Checked = True Then
            HV.IsoMetric = True                                'isometric contraction
        Else
            HV.IsoMetric = False                              'isotonic contraction
        End If
        HV.isometricL = CDbl(txthalfSL.Text)          'get the halfsarcomere length from the textbox
        HV.Fext = CDbl(txtFext.Text)                       'get Fext from the textbox

        HV.sclI1I2 = 1     'CDbl(txtI1I2.Text)                    'scaling factor for kI1I2 of the late scattered mode Na channel

        Tfreeze = MaxX1 + 1   'CDbl(txtTfreeze.Text)           'time to freeze slow variables

        HV.IsMClamp = False                               'defalt value

        IsFreezeSR = False

        IsFreezeSlowV = False

        IsAddCaNa = False

        HV.fNaK = 1

    End Sub

    Private Sub DefineGraph()
        graphVm1 = New Graph2014(pbVm, MinX1, MaxX1, MinY1, MaxY1)
        graphIm2 = New Graph2014(pbCurrent, MinX1, MaxX1, MinY2, MaxY2)
        graphConc3 = New Graph2014(pbConcentration, MinX1, MaxX1, MinY3, MaxY3)
        graphGate4 = New Graph2014(pbGate1, MinX4, MaxX4, MinY4, MaxY4)
        graphGate7 = New Graph2014(pbGate2, MinX4, MaxX4, MinY4, MaxY4)
        graphTimeChange6 = New Graph2014(pb6, MinX6, MaxX6, MinY6, MaxY6)
        graphGate8 = New Graph2014(pbGate8, MinX4, MaxX4, MinY4, MaxY8)
        graphGate9 = New Graph2014(pbGate9, MinX4, MaxX4, MinY4, MaxY9)

    End Sub

    Private Sub ClearGraph()
        graphVm1.Clear()
        graphIm2.Clear()
        graphConc3.Clear()
        graphGate4.Clear()
        graphGate7.Clear()
        graphTimeChange6.Clear()
        graphGate8.Clear()
        graphGate9.Clear()

    End Sub

    Private Sub DrawAxes()
        graphVm1.DrawAxis(IntervalX1, IntervalY1, "", 8)
        graphIm2.DrawAxis(IntervalX1, IntervalY2, "", 8)
        graphConc3.DrawAxis(IntervalX1, IntervalY3, "", 8)
        graphGate4.DrawAxis(IntervalX4, IntervalY4, "", 8)
        graphGate7.DrawAxis(IntervalX4, IntervalY4, "", 8)
        graphTimeChange6.DrawAxis(IntervalX6, IntervalY6, "", 8)
        graphTimeChange6.PlotLine(0, MinY6, 0, MaxY6, BlackPen)
        graphGate8.DrawAxis(IntervalX4, IntervalY8, "", 8)
        graphGate9.DrawAxis(IntervalX4, IntervalY9, "", 8)
        'graphCa0013.DrawAxis(IntervalX4, IntervalY13, "", 8)

    End Sub


    Private Sub PlotResults()
        If TtoPlot > maxTtoPlot Then                                                  'time to plot
            'If Vtest <= 0 Then
            graphVm1.PlotPoint(sweepTime, HV.Vm, gradient.PenRedBlue(HV.Vm, -50, 30))

            graphIm2.PlotPoint(sweepTime, HV.ICaL, gradient.PenRedBlue(HV.Vtest, -50, 30))
            graphConc3.PlotPoint(sweepTime, HV.Cafree_blk * 1000, gradient.PenRedBlue(HV.Vtest, -50, 30))    'Ion concentrations

            If sweepTime > HV.VtestOn And sweepTime < HV.VtestOn + 30 Then
                graphGate4.PlotPoint(sweepTime, (HV.Yooo), gradient.PenRedBlue(HV.Vtest, -50, 30))
                graphGate7.PlotPoint(sweepTime, (HV.Ycoo), gradient.PenRedBlue(HV.Vtest, -50, 30))
                graphGate8.PlotPoint(sweepTime, (HV.Ycco), gradient.PenRedBlue(HV.Vtest, -50, 30))
                graphGate9.PlotPoint(sweepTime, (HV.Yoco), gradient.PenRedBlue(HV.Vtest, -50, 30))

            End If

            'graphCa0013.PlotPoint(sweepTime, HV.Ca_nd00 * 1000, gradient.PenRedBlue((HV.Vtest + 30), 0, 60))


            TtoPlot = 0                                                  'reset the timer
        Else
            TtoPlot = TtoPlot + dt                                      'msec, interval of point plot
        End If
    End Sub


    Private Sub WriteCSV()
        'If sweepTime >= RecordTimeStart And sweepTime <= RecordTimeStart + RecordDuration Then
        '    If TtoRecord >= RecordInterval Then

        '        sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & ",", _
        '              sweepTime, Vm, slopeVmax)


        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' for lead potential analysis'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & ",", _
        '      sweepTime, Vm, VL.TempVL1(0), VL.TempVL1(3))

        'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & "," & "{6:E}" & "," & "{7:E}" & "," & "{8:E}" & "," _
        '          & "{9:E}" & "," & "{10:E}" & "," & "{11:E}" & "," & "{12:E}" & "," & "{13:E}" & "," & "{14:E}" & ",", _
        '         sweepTime, pO_INa_TM, pO_INa_LSM, pO_CaL_jnc, pO_CaL_nrs, pO_CaL_blk, pO_IKs_nrs, pO_IKs_blk, Vrctf_Kpl, _
        '         pO_IKto, pO_LCa_nrs, pO_LCa_blk, pO_IK1, pO_IKr, pO_IKTP)
        'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & "," & "{6:E}" & "," & "{7:E}" & ",", _
        '         sweepTime, Nai, Ki, Ca_jnc, Ca_nrs, Ca_blk, MgATP_cyt, MgADP_cyt)

        '      sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & "," & "{6:E}" & "," & "{7:E}" & "," & "{8:E}" & "," _
        '& "{9:E}" & "," & "{10:E}" & "," & "{11:E}" & "," & "{12:E}" & "," & "{13:E}" & "," & "{14:E}" & "," _
        '& "{15:E}" & "," & "{16:E}" & "," & "{17:E}" & "," & "{18:E}" & "," & "{19:E}" & "," & "{20:E}" & "," & "{21:E}" & "," & "{22:E}" & ",", _
        'sweepTime, INa_TM, INa_LSM, ICaLCa_jnc + ICaLNa_jnc + ICaLK_jnc, ICaLCa_nrs + ICaLNa_nrs + ICaLK_nrs, ICaLCa_blk + ICaLNa_blk + ICaLK_blk, _
        'IKs_K_nrs + IKs_Na_nrs, IKs_K_blk + IKs_Na_blk, IKpl, IKto, IbNSC, ICab_nrs, ICab_blk, ILCa_Na_nrs + ILCa_K_nrs, ILCa_Na_blk + ILCa_K_blk, _
        'IK1, IKr, IKATP, IPMCA_Ca_nrs, IPMCA_Ca_blk, INaK, INCXNa_nrs + INCXCa_nrs, INCXNa_blk + INCXCa_blk)

        'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & ",", _
        '      sweepTime, VL.TempVL1(1), VL.TempVL1(2))
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


        'sw1.Write(Chr(13) & Chr(10))

        'TtoRecord = TtoRecord - RecordInterval
        '    End If
        'End If
        'TtoRecord += dt
    End Sub

    Private Sub WriteCSVB()

        'sw1.Write("{0:E}" & "," & "{1:E}" & "," & "{2:E}" & "," & "{3:E}" & "," & "{4:E}" & "," & "{5:E}" & ",", _
        '             elapsedTime, maxICaL, Cafree_SRrl, maxFb, Nai, maxCablk)
        'sw1.Write(Chr(13) & Chr(10))

    End Sub

    Private Sub WritetxtBox()
        'txtVm.Text = Format(maxValue1, "###.#########")
        'txtNai.Text = Format(Ca_SRrl, "##.##########")
        'txtNanrs.Text = Format(maxValue2, "##.##########")
        'txtKblk.Text = Format(Nai, "###.#########")
        'txtCai.Text = Format(maxValue3, "##.#####")
        'txtCaj.Text = Format(0, "###.########")
        'txtCasl.Text = Format(0, "##.########")

        'txtATPi.Text = Format(ATPt_cyt, "ATPi = ##.####")
        'txtCasl.Text = Format(maxValue3, "##.########")
        'txtCaSR.Text = Format(Ca_SRrl, "##.######")

    End Sub

    'Private Sub RecordingCondition()
    '    FileName1 = Path.Combine(Application.StartupPath, "xresult1.csv")
    '    sw1 = New StreamWriter(FileName1, False)

    '    If RecordTimeStart + RecordDuration > MaxX1 Then
    '        RecordDuration = MaxX1 - RecordTimeStart

    '    End If

    '    TtoRecord = -RecordTimeStart                 'time interval for saving the data points on the CVS file

    '    If RecordInterval < dt Then
    '        RecordInterval = dt
    '    End If
    'End Sub




    Private Sub cbReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbReset.Click
        numSweep = RepeatN + 1
        HV.testV = 50.1
        'sweepTime = MaxX1 + 5
    End Sub


    Private Sub cbErase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbErase.Click

        graphVm1.Clear()
        graphIm2.Clear()
        graphConc3.Clear()
        graphGate4.Clear()
        'graphBuffer5.Clear()

        graphVm1.Clear()
        graphIm2.Clear()
        graphConc3.Clear()
        graphGate4.Clear()
        graphGate7.Clear()
        'graphBuffer5.Clear()
        graphTimeChange6.Clear()
        graphTimeChange6.Clear()
        graphGate8.Clear()
        graphGate9.Clear()
        'graphGate10.Clear()
        'graphSRCa11.Clear()
        'graphRate12.Clear()

        DrawAxes()



    End Sub


    Private Sub ButtonEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEnd.Click
        End
    End Sub


    Private Sub GroupBox1_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GroupBox1.Enter

    End Sub
    Private Sub pbGate8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbGate8.Click

    End Sub
    Private Sub pbVm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbVm.Click

    End Sub
    Private Sub pbCurrent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbCurrent.Click

    End Sub
    Private Sub pbConcentration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbConcentration.Click

    End Sub
    Private Sub pbGate1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbGate1.Click

    End Sub
    Private Sub pbBuffer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub
    Private Sub GroupBox3_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

End Class